%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Cheatsheet
% LaTeX Template
% Version 1.0 (12/12/15)
%
% This template has been downloaded from:
% http://www.LaTeXTemplates.com
%
% Original author:
% Michael Müller (https://github.com/cmichi/latex-template-collection) with
% extensive modifications by Vel (vel@LaTeXTemplates.com)
%
% License:
% The MIT License (see included LICENSE file)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%----------------------------------------------------------------------------------------
%	PACKAGES AND OTHER DOCUMENT CONFIGURATIONS
%----------------------------------------------------------------------------------------

\documentclass[11pt]{scrartcl} % 11pt font size

\usepackage[utf8]{inputenc} % Required for inputting international characters
\usepackage[T1]{fontenc} % Output font encoding for international characters

\usepackage[margin=0pt, landscape]{geometry} % Page margins and orientation

\usepackage{graphicx} % Required for including images

\usepackage{color} % Required for color customization
\definecolor{mygray}{gray}{.75} % Custom color

\usepackage{url} % Required for the \url command to easily display URLs

\usepackage[ % This block contains information used to annotate the PDF
colorlinks=false, 
pdftitle={Cheatsheet}, 
pdfauthor={Elias Kuepper}, 
pdfsubject={Julia Cheatsheet}, 
pdfkeywords={Julia, Cheatsheet}
]{hyperref}

\setlength{\unitlength}{1mm} % Set the length that numerical units are measured in
\setlength{\parindent}{0pt} % Stop paragraph indentation

\renewcommand{\dots}{\ \dotfill{}\ } % Fills in the right amount of dots

\renewcommand*\ttdefault{lcmtt}
\renewcommand*\ttdefault{cmvtt}
\renewcommand*\familydefault{\ttdefault} %% Only if the base font of the document is to be typewriter style
\usepackage[T1]{fontenc}

\newcommand{\command}[2]{#1~\dotfill{}~\textit{#2}\\} % Custom command for adding a shorcut

\newcommand{\sectiontitle}[1]{\paragraph{#1} \ \\} % Custom command for subsection titles

%----------------------------------------------------------------------------------------

\begin{document}

\begin{picture}(297,210) % Create a container for the page content

%----------------------------------------------------------------------------------------
%	TITLE SECTION 
%----------------------------------------------------------------------------------------

\put(5,200){ % Position on the page to put the title
\begin{minipage}[t]{210mm} % The size and alignment of the title
\section*{Cheatsheet Julia} % Title
\end{minipage}
}

%----------------------------------------------------------------------------------------
%	FIRST COLUMN SPECIFICATION
%----------------------------------------------------------------------------------------

\put(10,180){ % Divide the page
\begin{minipage}[t]{85mm} % Create a box to house text

%----------------------------------------------------------------------------------------
%	HEADING ONE
%----------------------------------------------------------------------------------------

\sectiontitle{Getting started}
			

\command{? *function name*}{help}
\command{\#...}{single line command}
\command{\#= ... =\#}{multi line command}
\command{typeof()}{determine type}
\command{;*command*}{using shell command}

\sectiontitle{Packages}

\command{Pkg.add("Example")}{adding}
\command{using Example}{activating for usage}

\sectiontitle{Data structures}
\command{favanimals=("buffalo","eagle")}{create immutable tuple}
\command{favanimals[1]}{index tuple}
\\
\command{myphonebook = Dict("Jenny" => "867-5309", "Ghostbusters" => "555-2368")}{create dict}
\command{myphonebook["Jenny"]}{grab value}
\command{myphonebook["Kramer"] = "555-FILK"}{add}
\command{pop!(myphonebook, "Kramer") }{delete}
\\
\command{friends = ["Ted", "Robyn", 3]}{create Array}
\command{friends[3] = "Baby Bop"}{indexing to edit}
\command{push!(friends,"Josh")}{adds item to end}
\command{pop!(friends)}{removes last item}
\command{shift!(friends)}{removes first item}
\command{numbers = [[1, 2], [4, 5]]}{multi dimensions}
\command{num=numbers}{new access to entries}
\command{num=copy(numbers)}{copying}
\command{A[5,3:end]}{vector 3rd to end in 5th row of A}
\command{v = [3, 5, 2]\\
	sort(v)}{sorted array returned, v unchanged}
\command{sort!(v)}{sorted array returned, v changed}
%----------------------------------------------------------------------------------------

\end{minipage} % End the first column of text
} % End the first division of the page

%----------------------------------------------------------------------------------------
%	SECOND COLUMN SPECIFICATION 
%----------------------------------------------------------------------------------------

\put(105,180){ % Divide the page
\begin{minipage}[t]{85mm} % Create a box to house text

\sectiontitle{Matrix-Construction}

\command{fill(1.0, (5,5))}{5x5 Array with 1.0}
\command{rand(5,5)}{random 5x5 matrix entries: [0,1)}
\command{randn(10)}{Gaussian (mean 0, std.dev. 1)}
\command{eye(5)}{5x5 identity matrix}
\command{diagm(x)}{diagonal matrix with y}
\command{linspace(1,4,20)}{20 eq spaced points 1 to 4}
\command{[i + 3*j for j in 0:2, i in 1:3]}{create compr.}

\sectiontitle{Strings}

\command{s1 = "Elias"}{create string}		
s2 = """A string with "qoutes". ""\\
\command{c1 = 'a'}{create character}
println("Name is \$s1 and am \$(2018-1996)")\\
\command{string(s1, s2), s1*s2, "\$s1\$s2"}{Concatenation}
\command{repeat("Hi ",10)}{Repitition}

\sectiontitle{Loops}

\command{while *condition*\\
	... *loop body*...\\
	end}{while loop}\\
\command{for *var* in *loop iterable*\\
	...*loop body*...\\
	end}{for loop}\\
\command{break}{exit loop}
\command{continue}{Exit iteration}		
					
%----------------------------------------------------------------------------------------

\end{minipage} % End the second column of text
} % End the second division of the page

%----------------------------------------------------------------------------------------
%	THIRD COLUMN SPECIFICATION 
%----------------------------------------------------------------------------------------

\put(200,180){ % Divide the page
\begin{minipage}[t]{85mm} % Create a box to house tex

\sectiontitle{Conditionals} % Heading five

\command{if *condition 1*\\
	...*option 1*...\\
	elseif *condition 2a* \& *condition 2b*\\
	...*option 2*...\\
	else\\
	...*option 3*...\\
	end}{if-condition}\\
\command{(x>y) ? x : y}{if x>y: x else y}
\command{(x > y) \&\& println(x)}{conditonally evaluate}	

\sectiontitle{Functions}

\command{function f(x)\\
	x\^\ 2\\
	end}{generic declaration}
\command{f2(x) = x\^\ 2}{one line declaration}
\command{f3 = x -> x\^\ 2}{"anonymous" declaration}
\command{f(42), f2(42), f3(42)}{call function}
\command{map(f, [1, 2, 3])}{call function on all elements}
\command{f.([1, 2, 3])}{broadcast on all elements}

	\sectiontitle{Multiple dispatch}
	
	\command{foo(x::String) = println("Is str")}{Specify type}
	\command{foo(x::Int) = println("Is int")}{Multipl dispatch}
	\command{methods(foo)}{check the different methods}
	\command{@which foo(3)}{check which is used}
	\command{foo(x)= println("Take all")}{fallback option}


%----------------------------------------------------------------------------------------

\end{minipage} % End the third column of text
} % End the third division of the page
\end{picture} % End the container for the entire page
\newpage
%----------------------------------------------------------------------------------------
\begin{picture}(297,210) % Create a container for the page content

\put(5,200){ % Position on the page to put the title
	\begin{minipage}[t]{210mm} % The size and alignment of the title
	
	
	\end{minipage}
}

%----------------------------------------------------------------------------------------
%	FIRST COLUMN SPECIFICATION
%----------------------------------------------------------------------------------------

\put(10,180){ % Divide the page
	\begin{minipage}[t]{85mm} % Create a box to house text
	
	
	\sectiontitle{Basic linear algebra}
	
	\command{A*x}{Multiplication}
	\command{A'\ , transpose(A)}{conjugate transpose}
	\command{A'A}{transposed multiplication}
	\command{A\textbackslash b}{Solving linear system A*x=b\\ \small least squares solution if we have an overdetermined linear system\\ minimum norm least squares solution if we have a rank-deficient least squares problem}
	\command{inv(A)}{inverse of A}
	\command{$\lambda$, V=eig(A)}{eigenvalues and eigenvectors}
	
	\sectiontitle{Constants}
	\command{pi \textit{or}  $\pi$}     {3.1415}
	\command{e}        {2.7182}
	\command{im}       {real(im * im) == -1}
	\command{catalan}  {0.9159}
	\command{$\gamma$}        {0.5772}
	\command{$\theta$}        {1.6180}
	
	\sectiontitle{Plotting}
	
	\command{
		using Plots\\
		gr() \textit{or} plotlyjs()}{load GR or Plotlyjs}
	\command{x=-10:10\\
		plot(x,x.\^\ 2, label="line")}{plotting $y=x^2$}
	\command{scatter!(x, x,x.\^\ 2, label="points")}{! to add}
	\command{xlabel \textit{or} ylabel \textit{or} titel !("Title")}{titles}
	\command{histogram2d(x,y,nbins=20,colorbar=true)}{}
	\command{ using Vega\\
		areaplot(x = x, y = y, group = g, stacked = true)}{}

	\end{minipage} % End the first column of text
} % End the first division of the page


%----------------------------------------------------------------------------------------
%	SECOND COLUMN SPECIFICATION 
%----------------------------------------------------------------------------------------

\put(105,180){ % Divide the page
	\begin{minipage}[t]{85mm} % Create a box to house text
	\sectiontitle{Data Science}
	
	\command{P,H = CSV.read("tab.csv",header=true)}{read in}
	\command{CSV.write("table.csv", P)}{write}
	\command{using DataFrames\\
		df = readtable("tab.csv")}{DataFrames}
	\command{df = DataFrame(y = P[:,1], lang = P[:,2])}{}\\
	\command{coalesce.([1.0, missing], 0.0)}{Replace missing}
	\command{cal = @data([11,47,10])\\
		food = @data(["apple", "cucumber", "tomato"])\\
		df=DataFrame(item=food,cal=cal)}{create df}\\
	\command{describe(df)}{quick statistic}
	\command{dropna(df)}{avoid problem with NA}
	\command{mean(cal)}{mean}
	\command{filter\_df = df[df[:cal].>10,:]}{Filtering}
	\command{by(filter\_house,:\_type,size}{Filtering by}\\
	\command{using Clustering\\
		kmeans(X,k)}{Clustering Array X to number k}
	
\sectiontitle{Optimization}

\command{using JUMP, Cbc \textit{or} Ipopt\\
	m = Model(solver=CbcSolver() \textit{or}\\ IpoptSolver())}{define Model (LP or MIP)}
\command{@variable(m, *matrix**limit*, *VarType*)}{}
\command{@constraint(m, *matrix*, *condition*}{}
\command{sum(x[i, j] for i = 1:9)==1)}{sum as condition}
\command{@objective(m, Min \textit{or} Max, *objective* )}{}
\command{solve(m)}{Call solver}
\command{getvalue(*variable*)}{}
	
	\end{minipage} % End the second column of text
} % End the second division of the page

%----------------------------------------------------------------------------------------
%	THIRD COLUMN SPECIFICATION 
%----------------------------------------------------------------------------------------

\put(200,180){ % Divide the page
	\begin{minipage}[t]{85mm} % Create a box to house tex
	

	%----------------------------------------------------------------------------------------
	%	FOOTNOTE
	%----------------------------------------------------------------------------------------
	
	
	\linethickness{0.5mm} % Thickness of the footer line
	{\color{mygray}\line(1,0){30}} % Print the line with a custom color
	
	\footnotesize{
		Created by Elias Küpper, 2018\\
		\url{https://www.linkedin.com/in/elias-k\%C3\%BCpper/}\\
		Based on Julia \& IJulia Cheat-sheet and JuliaBox Tutorials
		Template created by John Smith, 2015\\ 
		
		Released under the MIT license.
	}
	
	%----------------------------------------------------------------------------------------
	
	\end{minipage} % End the third column of text
} % End the third division of the page
\end{picture} % End the container for the entire page

\end{document}